<template>
  <td
    :class="className"
    @click="() => this.$emit('handleClickedCell', {xPosition: this.xPosition, yPosition:this.yPosition})"
    @mouseover="() => this.$emit('handleHoverCell', {xPosition: this.xPosition, yPosition:this.yPosition})"
  >
    <img class='icon' :src="require(`../assets/${image}.png`)" v-if="image" />
  </td>
</template>

<script lang="ts">
import Vue from "vue";
import { Component, Prop, Watch } from "vue-property-decorator";
import { PieceName, Styling } from '../models/pieceModels';

@Component
export default class Cell extends Vue {
  @Prop() readonly piece!: PieceName;

  @Prop() readonly styling!: Styling;

  @Prop() readonly xPosition!: number;

  @Prop() readonly yPosition!: number;

  @Prop({ required: false }) readonly isPlayerOne!: boolean;

  get className(): string {
    switch (this.styling) {
      case Styling.ATTACK_HIGHLIGHT:
        return "Cell Cell__highlightAttack";
      case Styling.MOVEMENT_HIGHLIGHT:
        return "Cell Cell__highlightMovement";
      default:
        return "Cell";
    }
  }

  get image() {
    let image: string;

    switch(this.piece) {
      case PieceName.ARCHER:
        image = 'high-shot';
        break;
      case PieceName.BISHOP:
        image = 'pope-crown';
        break;
      case PieceName.CAVALRY:
        image = 'horse-head';
        break;
      case PieceName.SOLDIER:
        image = 'crossed-swords';
        break;
      case PieceName.WIZARD:
        image = 'pointy-hat';
        break;
      default:
        return null;    
    }

    return this.isPlayerOne ? image : `${image}-blue`;
  }
}
</script>

<style scoped>
.Cell {
  height: 82px;
  width: 86px;
  border: 1px solid blue;
}

.Cell__highlightAttack {
  filter: hue-rotate(200deg);
  background-color: orange;
}

.Cell__highlightMovement {
  filter: brightness(150%);
  background-color: blue;
}

.icon {
  height: 80px;
}
</style>
